<!DOCTYPE html>

<html>

<head>
  <title>Hello p5.js</title>

  <meta http-Equiv="Cache-Control" Content="no-cache" />
  <meta http-Equiv="Pragma" Content="no-cache" />
  <meta http-Equiv="Expires" Content="0" />

  <!--script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/0.5.16/p5.min.js"></script-->
  <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>

  <!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/0.8.0/p5.min.js"></script> -->
  <!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/0.8.0/addons/p5.dom.min.js"></script> -->
  <!-- <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/0.8.0/addons/p5.sound.min.js"></script> -->

<!--
  <script type="text/javascript" src="./plugins/p5_jp.js"></script>
  <script type="text/javascript" src="./plugins/p5.dom.min.js"></script>
  <script type="text/javascript" src="./plugins/p5.sound.min.js"></script>
-->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/1.1.9/p5.js" crossorigin=""></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/1.1.9/addons/p5.sound.min.js" crossorigin=""></script>
  <!-- <script type="text/javascript" src="./plugins/platform.js"></script> -->
  <script type="text/javascript" src="./plugins/mobile-detect.min.js"></script>

  <style>
    body {
      margin: 0;
      overflow: hidden;
      display: flex;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100vh;
    }
    canvas {
      background: #FFF;
    }
  </style>
</head>
<body>
</body>
</html>

<script type="text/javascript">
  var code = window.parent.EDITOR_GLOB.sourceCode;
  var mode = window.parent.EDITOR_GLOB.mode;

  // 改行を削除します。
  // code = code.replace(/\r?\n/g,"");

  // setup関数やdraw関数の記述がない場合、
  // 強制的に'USE NO SETUP AND DRAW'モードにします。
  var setup_exist_regex = new RegExp(/function *setup *\( *\) *{/);
  var draw_exist_regex = new RegExp(/function *draw *\( *\) *{/);
  var setup_exist = setup_exist_regex.test(code);
  var draw_exist = draw_exist_regex.test(code);

  // setup関数もdraw関数もない場合
  if (setup_exist == false && draw_exist == false) {
    if (mode != 'USE NO SETUP AND DRAW') {
      alert("プログラムをsetup関数とdraw関数に整理しましょう。")
    }
    mode = 'USE NO SETUP AND DRAW';
  }
  // setup関数は無いが、draw関数はある場合
  else if (setup_exist == false && draw_exist == true) {
  }
  // setup関数はあるが、draw関数がない場合
  else if (setup_exist == true && draw_exist == false) {
  }
  // setup関数もdraw関数もある場合
  else {
  }

  if(code.indexOf('USE NO SETUP AND DRAW')!=-1 || mode == 'USE NO SETUP AND DRAW'){

    var setupCodeDefault = `
      createCanvas(300,300);
      background(250, 250, 250);
      strokeWeight(3);
      ${code}
    `;

    var setupCodeResult;
    var codeArray = setupCodeDefault.split(';');
    for(var line of codeArray){
      setupCodeResult += `${line};`;
      if(line.indexOf('createCanvas') != -1){
        setupCodeResult += "strokeWeight(3);";
      }
    }

    var setupFunction = `function setup(){ ${setupCodeResult} }`;

    code = setupFunction;

  }else{
    //code = 'function preload(){ noFill(); }' + code;
  }

  try { // 実行を試みる
    console.log(code);
    eval(code);
  }
  catch (e) {
    japanese_error_message(e);
    var sketche = window.parent.document.getElementsByClassName('wrap-sketche');
    $(sketche).toggle();
  }

  function japanese_error_message(e) {
    var err = e.toString().split(':');
    var type = err[0];
    var msg_jp = "", msg_en = err[1];

    if (type == 'ReferenceError'){

      // [CASE: 1]
      // var x = y; <--- グローバル領域で、定義していない変数yを代入しようとすると発生するエラーです。

      msg_jp = "エラー：変数がつくられていないようです。";
      alert(msg_jp);
    }
    else if (type == 'SyntaxError') {

      // [CASE: 1]
      // function setup() {
      //   createCanvas(300, 300);
      //   background(255);
      //  <--- }を閉じ忘れると発生するエラーです。
      //
      // function draw() {
      //
      // }

      msg_jp = "エラー：プログラムの構文に間違いがあるようです。どこかで中括弧を閉じ忘れていたり、プログラムを打ち間違えたりしていないかどうか、チェックしましょう。";
      alert(msg_jp);
    }
    else {

    }
  }

  var touchX;
  var touchY;
  var sketchCanvas;
  window.onload = function() {
    $('#defaultCanvas0').bind('touchmove', function() {
      //event.preventDefault();                     // ページが動いたり、反応を止める（A タグなど）
      touchX = event.changedTouches[0].pageX; // X 座標の位置
      touchY = event.changedTouches[0].pageY; // Y 座標の位置
      mouseX = event.changedTouches[0].pageX; // X 座標の位置
      mouseY = event.changedTouches[0].pageY; // Y 座標の位置
    });

    sketchCanvas = document.getElementsByTagName('canvas')[0];
  };

  var md = new MobileDetect(window.navigator.userAgent);
  // console.log( md.mobile() );          // 'Sony'
  // console.log( md.phone() );           // 'Sony'
  // console.log( md.tablet() );          // null
  // console.log( md.userAgent() );       // 'Safari'
  // console.log( md.os() );              // 'AndroidOS'
  // console.log( md.is('iPhone') );      // false
  // console.log( md.is('bot') );         // false
  // console.log( md.version('Webkit') );         // 534.3
  // console.log( md.versionStr('Build') );       // '4.1.A.0.562'
  // console.log( md.match('playstation|xbox') ); // false

  window.onerror = function (msg, file, line, column, err) {
    var msg_en = msg.split(":");
    var msg_jp = ""

    var os = md.os();
    var agent = md.userAgent();

    if (os == 'iOS') {
      if (agent == "Safari" || agent == "Chrome" || agent == "Firefox") {
        // msg_en[0] = ReferenceError
        // msg_en[1] = Can't find variable.
        // msg_en[2] = backgrund
        // line = 4;
        // alert("エラー：" + (line - 1) + "行目の" + msg_en[2] + "に間違いがあるようです。");
      }
    }
    else if (os == 'AndroidOS') {
        // msg_en[0] = Uncaught ReferenceError
        // msg_en[1] = backgrund is not defined
        // msg_en[2] = undefined
        // line = 4;
        if (agent == "Chrome") {
          var v = msg_en[1].replace(" is not defined", "");
          // alert("エラー：" + (line - 1) + "行目の" + v + "に間違いがあるようです。");
        } else {

        }
    }
    else {

    }


  };


</script>
